codeforces 1042 C. Array Product(贪心)

codeforces 1042 C. Array Product(贪心)


You are given an array a consisting of n integers. You can perform the following operations with it:

Choose some positions i and j (1≤i,j≤n,i≠j), write the value of ai⋅aj into the j-th cell and remove the number from the i-th cell;

Choose some position i and remove the number from the i-th cell (this operation can be performed no more than once and at any point of time, not necessarily in the beginning).

The number of elements decreases by one after each operation. However, the indexing of positions stays the same. Deleted numbers can’t be used in the later operations.

Your task is to perform exactly n−1 operations with the array in such a way that the only number that remains in the array is maximum possible. This number can be rather large, so instead of printing it you need to print any sequence of operations which leads to this maximum number. Read the output format to understand what exactly you need to print.

Input

The first line contains a single integer n(2≤n≤2⋅10^5) — the number of elements in the array.

The second line contains n integers a1,a2,…,an (−109≤ai≤109) — the elements of the array.

Output

Print n−1 lines. The k-th line should contain one of the two possible operations.

The operation of the first type should look like this: 1 ik jk, where 1 is the type of operation, ik and jk are the positions of the chosen elements.

扫描二维码关注公众号,回复: 3585485 查看本文章

The operation of the second type should look like this: 2 ik, where 2 is the type of operation, ik is the position of the chosen element. Note that there should be no more than one such operation.

If there are multiple possible sequences of operations leading to the maximum number — print any of them.

Examples

Input

5
5 -2 0 1 -3

Output

2 3
1 1 2
1 2 4
1 4 5

Input

5
5 2 0 4 0

Output

1 3 5
2 5
1 1 2
1 2 4

Input

2
2 -1

Output

2 2

Input

4
0 -10 0 0

Output

1 1 2
1 2 3
1 3 4

Input

4
0 0 0 0

Output

1 1 2
1 2 3
1 3 4

Note

Let X be the removed number in the array. Let’s take a look at all the examples:

The first example has, for example, the following sequence of transformations of the array: [5,−2,0,1,−3]→[5,−2,X,1,−3]→[X,−10,X,1,−3]→

[X,X,X,−10,−3]→[X,X,X,X,30]. Thus, the maximum answer is 30. Note, that other sequences that lead to the answer 30

are also correct.

The second example has, for example, the following sequence of transformations of the array: [5,2,0,4,0]→[5,2,X,4,0]→[5,2,X,4,X]→[X,10,X,4,X]→

[X,X,X,40,X]

. The following answer is also allowed:

1 5 3
1 4 2
1 2 1
2 3

Then the sequence of transformations of the array will look like this: [5,2,0,4,0]→[5,2,0,4,X]→[5,8,0,X,X]→[40,X,0,X,X]→

[40,X,X,X,X].

The third example can have the following sequence of transformations of the array: [2,−1]→[2,X].

The fourth example can have the following

sequence of transformations of the array [0,−10,0,0]→[X,0,0,0]→[X,X,0,0]→[X,X,X,0].

The fifth example can have the following sequence of transformations of the array: [0,0,0,0]→[X,0,0,0]→[X,X,0,0]→[X,X,X,0].


题意:给你一个长度为n的序列,你有两种操作:
1 把i,j位置的数相乘,保留到 j 位置,删除 i 位置上的数;
2 直接删除某一位的数字 只能用一次
总共n-1个操作 最后问如何删除能保留最大那位数

思路:正数直接相乘,零相乘保留到一位,负数分两种情况,如果负数为偶数个,直接相乘然后和正数最后的数相乘,删除零。如果负数为奇数个,用绝对值最小的负数和0相乘,然后删除。

直接暴力
忽略我丑陋的代码

#include<bits/stdc++.h>
#define fi first
#define se second
#define FOR(a) for(int i=0;i<a;i++)
#define show(a) cout<<a<<endl;
#define show2(a,b) cout<<a<<" "<<b<<endl;
#define show3(a,b,c) cout<<a<<" "<<b<<" "<<c<<endl;
using namespace std;

typedef long long ll;
typedef pair<int,int> P;
typedef pair<P,int> LP;
const ll inf=0x3f3f3f3f;
const int N=2e6;
const ll mod=1e9+7;

map<string,ll>  mp;
map<string ,int>ml;
ll n,m,k,b[N],f[N];
int did[N],vis[N],num[N];
string s,ss;
ll s1,s2,s3,s4=0,flag,tot,t,sum,pos, cnt,x,y,xx,yy,ans,dex1,dex2;

vector<ll> v;
//char v[150][150];

set<int> se;
P a[N];

bool cmp(P x,P y)
{
	return x.fi<y.fi;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin>>n;
	ll mx=-inf;
	ll cnt1=0,cnt2=0,j=1,t=0;
	for(int i=1;i<=n;i++)
	{
		cin>>x;
		if(x<0) cnt1++;
		if(x>0) {num[++cnt2]=i;}
		if(x<0) {a[j].fi=x;a[j].se=i;j++;}
		if(x==0){b[++cnt]=i;}
	}

	sort(a+1,a+cnt1+1,cmp);
	for(int i=1;i<cnt2;i++)
	{
		cout<<1<<" "<<num[i]<<" "<<num[i+1]<<endl;
		n--;
	}
	dex1=num[cnt2];
	for(int i=1;i<cnt;i++)
	{
		cout<<1<<" "<<b[i]<<" "<<b[i+1]<<endl;
		n--;
	}
	dex2=b[cnt];

	if(cnt1%2)
	{
		for(int i=1;i<=cnt1-2;i++)
		{
			cout<<1<<" "<<a[i].se<<" "<<a[i+1].se<<endl;
			flag=1;
			n--;
		}
		if(dex1&&flag)
		{
			cout<<1<<" "<<a[cnt1-1].se<<" "<<dex1<<endl;
			n--;
		}

		if(dex2&&n>2)
		{
			cout<<1<<" "<<a[cnt1].se<<" "<<dex2<<endl;
			cout<<2<<" "<<dex2<<endl;
		}
		else
		{
			cout<<2<<" "<<a[cnt1].se<<endl;
		}

	}
	else
	{
		for(int i=1;i<=cnt1-1;i++)
		{
			cout<<1<<" "<<a[i].se<<" "<<a[i+1].se<<endl;
			n--;
			flag=1;
		}
		if(dex1&&cnt1&&n>1&&flag)
		{
			cout<<1<<" "<<a[cnt1].se<<" "<<dex1<<endl;
		n--;
		}
		if(dex2&&n>1) cout<<2<<" "<<dex2<<endl;
	}
}

猜你喜欢

转载自blog.csdn.net/weixin_42640692/article/details/82989695